function PlayerClone::copyVehicle(%player)
{
  %vehicle = playermanager::playerNumToVehicleID(%player);
  exec("PCList.cs");
  echo("A" @ %PCVehicleCount);
  %newProfile = PlayerClone::analyzeVeh(%vehicle);

  for(%i=0; %i<%PCVehicleCount; %i++)
  {
    if(%PCVehicleProfile[%i] == %newProfile) return;
  }

  storeObject(%vehicle, "multiplayer\\PCVeh-" @ %PCVehicleCount @ ".veh");
  %PCVehicleCount++;
  echo("B" @ %PCVehicleCount);
  PlayerClone::writeVehicleList(%PCVehicleCount, %vehicle);
}


function PlayerClone::spawnRandomVehicle()
{
  exec("PCList.cs");
  %i = randomInt(1, %PCVehicleCount) - 1;
  echo(%i);
  echo(%PCVehicleFile[%i]);
  %vehicle = loadObject("AIVehicle", "multiplayer\\" @ %PCVehicleFile[%i]);
  return(%vehicle);
}


function PlayerClone::writeVehicleList(%PCNewVehicleCount, %vehicle)
{
  exec("PCList.cs");

  %PCVehicleFile[%PCVehicleCount] = "PCVeh-" @ %PCVehicleCount @ ".veh";
  %PCVehicleProfile[%PCVehicleCount] = PlayerClone::analyzeVeh(%vehicle);

  $PCplaceHolder = "PlayerClone Vehicle List";
  export("$PCplaceHolder", "multiplayer\\PCList.cs", overwrite);
  fileWrite( "multiplayer\\PCList.cs" , append, "%PCVehicleCount = " @ %PCNewVehicleCount @ ";");

  for(%i=0; %i<%PCNewVehicleCount; %i++)
  {
    fileWrite( "multiplayer\\PCList.cs" , append, "%PCVehicleFile[" @ %i @ "] = \"" @ %PCVehicleFile[%i] @ "\";");
    fileWrite( "multiplayer\\PCList.cs" , append, "%PCVehicleProfile[" @ %i @ "] = \"" @ %PCVehicleProfile[%i] @ "\";");
  }
}


//====================



function PlayerClone::analyzeVeh(%this)
{
  %componentCount = getComponentCount(%this);
  %index = 0;

  %output = getVehicleName(%this);

  while (%index < %componentCount) 
  {
    %id = getComponentId(%this, %index);
    %theName = nameStuff(%id);
    if(%index == 0) %output = %output @ ": " @ %theName;
    else %output = %output @ " " @ %theName;
    %index++;
  }

  %weaponCount = getWeaponCount(%this);
  %index = 0;
  while (%index < %weaponCount) 
  {
    %id = getWeaponId(%this, %index);
    %theName = nameGun(%id);
    %output = %output @ " " @ %theName;
    %index++;
  }

  echo(%output);
  return(%output);
}


function nameStuff(%thingie)
{
	if ((%thingie >= 100) && (%thingie <= 115))
	{
		return(nameEngineA(%thingie));
	}

	else if ((%thingie >= 128) && (%thingie <= 143))
	{
		return(nameEngineB(%thingie));
	}

	else if ((%thingie >= 200) && (%thingie <=230))
	{
		return(nameReactor(%thingie));
	}

	else if ((%thingie >= 300) && (%thingie <= 333))
	{
		return(nameShield(%thingie));
	}

	else if ((%thingie >= 400) && (%thingie <= 434))
	{
		return(nameSensor(%thingie));
	}

	else if ((%thingie >= 800) && (%thingie <= 807))
	{
		return(nameComputer(%thingie));
	}

	else if ((%thingie >= 926) && (%thingie <= 931))
	{
		return(nameArmor(%thingie));
	}

	else if ((%thingie >= 810) && (%thingie <= 914))
	{
		return(nameSpecial(%thingie));
	}

	else return("Unknown component");
}


function nameEngineA(%thingie)
{
	if(%thingie == 100)
	{
		return("HumanLight");
	}
	else if(%thingie == 101)
	{
		return("HumanHighOutput");
	}
	else if(%thingie == 102)
	{
		return("HumanLightAgility");
	}
	else if(%thingie == 103)
	{
		return("HumanStandardMedium");
	}
	else if(%thingie == 104)
	{
		return("HumanHighOutputMedium");
	}
	else if(%thingie == 105)
	{
		return("HumanMediumAgility");
	}
	else if(%thingie == 106)
	{
		return("HumanStandardHeavy");
	}
	else if(%thingie == 107)
	{
		return("HumanImprovedHeavy");
	}
	else if(%thingie == 108)
	{
		return("HumanHeavyCruise");
	}
	else if(%thingie == 109)
	{
		return("HumanHighOutputHeavy");
	}
	else if(%thingie == 110)
	{
		return("HumanHeavyAgility");
	}
	else if(%thingie == 111)
	{
		return("HumanStandardAssault");
	}
	else if(%thingie == 112)
	{
		return("HumanImprovedAssault");
	}
	else if(%thingie == 113)
	{
		return("HumanHeavyTurbine");
	}
	else if(%thingie == 114)
	{
		return("HumanHighOutputTurbine");
	}
	else if(%thingie == 115)
	{
		return("HumanSuperHeavy");
	}
	else return("Error");
}

function nameEngineB(%thingie)
{
	if(%thingie == 128)
	{
		return("CybridLightVehicle");
	}
	else if(%thingie == 129)
	{
		return("CybridLightAgility");
	}
	else if(%thingie == 130)
	{
		return("CybridStandardMedium");
	}
	else if(%thingie == 131)
	{
		return("CybridMediumCruise");
	}
	else if(%thingie == 132)
	{
		return("CybridImprovedMedium");
	}
	else if(%thingie == 133)
	{
		return("CybridMediumHighOutput");
	}
	else if(%thingie == 134)
	{
		return("CybridMediumAgility");
	}
	else if(%thingie == 135)
	{
		return("CybridStandardHeavy");
	}
	else if(%thingie == 136)
	{
		return("CybridHeavyHighOutput");
	}
	else if(%thingie == 137)
	{
		return("CybridHeavyAgility");
	}
	else if(%thingie == 138)
	{
		return("CybridStandardAssault");
	}
	else if(%thingie == 139)
	{
		return("CybridImprovedAssault");
	}
	else if(%thingie == 140)
	{
		return("CybridHighOutputAssault");
	}
	else if(%thingie == 141)
	{
		return("CybridHeavyAssault");
	}
	else if(%thingie == 142)
	{
		return("CybridHeavyAssaultTurbine");
	}
	else if(%thingie == 143)
	{
		return("CybridPiSuperHeavy");
	}
	else return("Error");
}


function nameReactor(%thingie)
{
	if (%thingie == 200)
	{
		return("HMicroReactor");
	}
	else if(%thingie == 201)
	{
		return("HSmallReactor");
	}
	else if(%thingie == 202)
	{
		return("HStandardReactor");
	}
	else if(%thingie == 203)
	{
		return("HMediumReactor");
	}
	else if(%thingie == 204)
	{
		return("HLargeReactor");
	}
	else if(%thingie == 205)
	{
		return("HMaximReactor");
	}
	else if(%thingie == 225)
	{
		return("CAlphaReactor");
	}
	else if(%thingie == 226)
	{
		return("CBetaReactor");
	}
	else if(%thingie == 227)
	{
		return("CGammaReactor");
	}
	else if(%thingie == 228)
	{
		return("CDeltaReactor");
	}
	else if(%thingie == 229)
	{
		return("CEpsilonReactor");
	}
	else if(%thingie == 230)
	{
		return("CThetaReactor");
	}
	else return("Unknown reactor");
}


function nameShield(%thingie)
{
	if(%thingie == 300)
	{
		return("StandardShield");
	}
	else if(%thingie == 301)
	{
		return("ProtectorShield");
	}
	else if(%thingie == 302)
	{
		return("GuardianShield");
	}
	else if(%thingie == 303)
	{
		return("FastChargeShield");
	}
	else if(%thingie == 304)
	{
		return("CenturionShield");
	}
	else if(%thingie == 305)
	{
		return("RepulsorShield");
	}
	else if(%thingie == 306)
	{
		return("TitanShield");
	}
	else if(%thingie == 307)
	{
		return("MedusaShield");
	}
	else if(%thingie == 326)
	{
		return("AlphaShield");
	}
	else if(%thingie == 327)
	{
		return("BetaShield");
	}
	else if(%thingie == 328)
	{
		return("GammaShield");
	}
	else if(%thingie == 329)
	{
		return("DeltaShield");
	}
	else if(%thingie == 330)
	{
		return("EpsilonShield");
	}
	else if(%thingie == 331)
	{
		return("ZetaShield");
	}
	else if(%thingie == 332)
	{
		return("EtaShield");
	}
	else if(%thingie == 333)
	{
		return("ThetaShield");
	}
	else return("Error");
}



function nameSensor(%thingie)
{
	if(%thingie == 400)
	{
		return("HBasicSensor");
	}
	else if(%thingie == 401)
	{
		return("Human Ranger Sensor");
	}
	else if(%thingie == 408)
	{
		return("HStandardSensor");
	}
	else if(%thingie == 409)
	{
		return("HLongbowSensor");
	}
	else if(%thingie == 410)
	{
		return("HInfiltratorSensor");
	}
	else if(%thingie == 411)
	{
		return("HCrossbowSensor");
	}
	else if(%thingie == 412)
	{
		return("HUltralightSensor");
	}
	else if(%thingie == 413)
	{
		return("HHoundSensor");
	}
	else if(%thingie == 414)
	{
		return("HThermalSensor");
	}
	else if(%thingie == 426)
	{
		return("Alpha SensorBasic");
	}
	else if(%thingie == 427)
	{
		return("BetaSensorLongRange");
	}
	else if(%thingie == 428)
	{
		return("GammaSensorStandard");
	}
	else if(%thingie == 429)
	{
		return("DeltaSensorLongbow");
	}
	else if(%thingie == 430)
	{
		return("EpsilonSensorInfiltrator");
	}
	else if(%thingie == 431)
	{
		return("ZetaSensorCrossbow");
	}
	else if(%thingie == 432)
	{
		return("EtaSensorUltralight");
	}
	else if(%thingie == 433)
	{
		return("ThetaSensorHound");
	}
	else if(%thingie == 434)
	{
		return("IotaSensorMotionDetector");
	}
	else return("Error");
}





function nameArmor(%thingie)
{
	if(%thingie == 926)
	{
		return("Carlam");
	}
	else if(%thingie == 927)
	{
		return("Quad");
	}
	else if(%thingie == 928)
	{
		return("Durac");
	}
	else if(%thingie == 929)
	{
		return("Ceramic");
	}
	else if(%thingie == 930)
	{
		return("Crystal");
	}
	else if(%thingie == 931)
	{
		return("Quicksilver");
	}
	else return("Error");
}



function nameComputer(%thingie)
{
	if(%thingie == 800)
	{
		return("166");
	}
	else if(%thingie == 801)
	{
		return("300");
	}
	else if(%thingie == 802)
	{
		return("450");
	}
	else if(%thingie == 805)
	{
		return("AlphaComp");
	}
	else if(%thingie == 806)
	{
		return("BetaComp");
	}
	else if(%thingie == 807)
	{
		return("GammaComp");
	}
	else return("Unknown computer");
}


function nameSpecial(%thingie)
{
	if(%thingie == 810)
	{
		return("Guardian");
	}
	else if(%thingie == 811)
	{
		return("Doppleganger");
	}
	else if(%thingie == 812)
	{
		return("AlphaECM");
	}
	else if(%thingie == 813)
	{
		return("BetaECM");
	}
	else if(%thingie == 820)
	{
		return("ThermalDiff");
	}
	else if(%thingie == 830)
	{
		return("Chameleon");
	}
	else if(%thingie == 831)
	{
		return("Cuttlefish");
	}
	else if(%thingie == 840)
	{
		return("SMod");
	}
	else if(%thingie == 845)
	{
		return("SCap");
	}
	else if(%thingie == 850)
	{
		return("SAmp");
	}
	else if(%thingie == 860)
	{
		return("LTAG");
	}
	else if(%thingie == 865)
	{
		return("AuxPower");
	}
	else if(%thingie == 870)
	{
		return("RCap");
	}
	else if(%thingie == 875)
	{
		return("FieldStab");
	}
	else if(%thingie == 880)
	{
		return("Rocket");
	}
	else if(%thingie == 885)
	{
		return("Turbine");
	}
	else if(%thingie == 890)
	{
		return("Nanorepair");
	}
	else if(%thingie == 900)
	{
		return("Angel");
	}
	else if(%thingie == 910)
	{
		return("AntiGrav");
	}
	else if(%thingie == 912)
	{
		return("Electrohull");
	}
	else if(%thingie == 914)
	{
		return("Ammopack");
	}
}

function nameGun(%thingie)
{
	if ((%thingie >= 1) && (%thingie <= 119))
	{
		return(nameGunA(%thingie));
	}

	else
	{
		return(nameGunB(%thingie));
	}
}


function nameGunA(%thingie)
{
	if(%thingie == 3)
	{
		return("Disrupter");
	}
	else if(%thingie == 101)
	{
		return("Las");
	}
	else if(%thingie == 102)
	{
		return("HLas");
	}
	else if(%thingie == 103)
	{
		return("CLas");
	}
	else if(%thingie == 104)
	{
		return("TLas");
	}
	else if(%thingie == 105)
	{
		return("EMP");
	}
	else if(%thingie == 106)
	{
		return("ELF");
	}
	else if(%thingie == 107)
	{
		return("Blaster");
	}
	else if(%thingie == 108)
	{
		return("HBlaster");
	}
	else if(%thingie == 109)
	{
		return("PBW");
	}
	else if(%thingie == 110)
	{
		return("Plasma");
	}
	else if(%thingie == 111)
	{
		return("Blink");
	}
	else if(%thingie == 112)
	{
		return("QGun");
	}
	else if(%thingie == 113)
	{
		return("MFAC");
	}
	else if(%thingie == 114)
	{
		return("Nano-infuser");
	}
	else if(%thingie == 115)
	{
		return("NaniteCannon");
	}
	else if(%thingie == 116)
	{
		return("ATC");
	}
	else if(%thingie == 117)
	{
		return("HATC");
	}
	else if(%thingie == 118)
	{
		return("EMC");
	}
	else if(%thingie == 119)
	{
		return("BC");
	}
	else return("Error");
}

function nameGunB(%thingie)
{
	if(%thingie == 120)
	{
		return("HBC");
	}
	else if(%thingie == 121)
	{
		return("Railgun");
	}
	else if(%thingie == 124)
	{
		return("PitViper8");
	}
	else if(%thingie == 125)
	{
		return("PitViper12");
	}
	else if(%thingie == 126)
	{
		return("Sparrow6");
	}
	else if(%thingie == 127)
	{
		return("Sparrow10");
	}
	else if(%thingie == 128)
	{
		return("Swarm6");
	}
	else if(%thingie == 129)
	{
		return("Minion");
	}
	else if(%thingie == 130)
	{
		return("Shrike");
	}
	else if(%thingie == 131)
	{
		return("Arach4");
	}
	else if(%thingie == 132)
	{
		return("Arach8");
	}
	else if(%thingie == 133)
	{
		return("Arach12");
	}
	else if(%thingie == 134)
	{
		return("HHG6");
	}
	else if(%thingie == 135)
	{
		return("HHG10");
	}
	else if(%thingie == 136)
	{
		return("HHG15");
	}
	else if(%thingie == 142)
	{
		return("Radgun");
	}
	else if(%thingie == 147)
	{
		return("Aphid");
	}
	else if(%thingie == 150)
	{
		return("SGun");
	}
	else return("Error");
}